#!/usr/bin/env python
#grow-shrink-live_dm.py
# Creator: TT http://gimpchat.com/viewtopic.php?f=9&t=20616
# This should allow user to adjust grow/shrink current selection with live preview
# Open Source
#
# Ver.1.0 initial relase
# 09/12/2023 Revision 1 by DM. set calculated shrink/grow and feather limits.
# 15/12/2023 Revision 2 by DM. changed colour mask opacity to 50%.
# 15/12/2023 Revision 3 by MrQ added: ofset, rotate,select mask color and opacity.
# 17/12/2023 Revision 4 by MrQ added: invert mask, spinner, if use Cancel:load old selection and remove chanel.
# 24/12/2023 Revision 5 added: change min/max slider by DM,option Activate Parameters:"
# 01/01/2024 Revision 6 by DM. changed update policy of sliders to DISCONTINUOUS.
# 22/01/2024 Revision 7 by DM. set calculated offx and offy limits.
# 22/01/2024 Revision 8 by DM. removed "apply_effect" from "apply_final" - believe not necessary.
# 22/01/2024 Revision 9 by DM. put limit calculation in an "if" statement so only calculated once.

###############################################################################################################
# 06/02/2024 Ver.2.0 by MrQ : modification on a copy of the layer (Top)
#                             remove selection fill (invert, color, opacity);
#                             change plugin name and name in menu; 
#                             added operations for the top layer: scale, offsets..
# 10/02/2024 Ver.2.1 by MrQ : added: - opacity;
#                                    - if there is no selection, add a crop function on each side
#                                      Designation of directions:
#                                      LR = Left to Right
#                                      RL = Right to Left
#                                      TB = Top to Bottom
#                                      BT = Bottom to Top
# 

from gimpfu import *
import gtk, gimpui
gimpui.gimp_ui_init ()
import math

# Global variables to store the parameters used for our effect/work to show preview or actual layer when user OK it
global_param1 = -1   # shrinkgrow radius
global_param2 = 0    # feather_radius
global_param3 = 100
global_param4 = 0 
global_param5 = 0 
global_param6 = 100 # opacity
global_param7 = 0
global_param8 = 0
global_param9 = 0
global_param10 = 0
global_param11 = 0

image = 0 #we'll set these when dialog() is called so that we can access them later
drawable = 0
has_preview = False
preview_layer = 0

selection_channel = 0
proceed_with_changes = False


def apply_effect(layer): #function to do work on either preview layer or actual drawable when user clicks OK
    global image, rprevious, fprevious
    radius = global_param1
    feather_radius = global_param2
	

    pdb.gimp_image_resize_to_layers(image)
    for layer in image.layers:	
	    pdb.gimp_layer_resize_to_image_size(layer)
		
    pdb.gimp_layer_add_alpha(pdb.gimp_image_get_layer_by_name(image, "Result"))
	
    pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,selection_channel)		
 
    if proceed_with_changes==1:

#########################################################################################	
        if global_param7 >0 :
            pdb.gimp_image_select_item(image, 3, pdb.gimp_image_get_layer_by_name(image, "Result"))		
            pdb.gimp_selection_translate(image, global_param7 - global_param4  , 0)   

        if global_param4 <0:
            #pdb.gimp_image_select_item(image, 2, pdb.gimp_image_get_layer_by_name(image, "Result"))
            pdb.gimp_image_select_item(image, 3, image.layers[0])		
            pdb.gimp_selection_translate(image,global_param4, 0)
			
			
        if global_param8 >0 :
            pdb.gimp_image_select_item(image, 3, image.layers[0])		
            pdb.gimp_selection_translate(image, 0, global_param8 - global_param5  )   

        if global_param5 <0:
            #pdb.gimp_image_select_item(image, 2, pdb.gimp_image_get_layer_by_name(image, "Result"))
            pdb.gimp_image_select_item(image, 3, image.layers[0])		
            pdb.gimp_selection_translate(image,0, global_param5)			
			
#############################################################################################
			
    
        if radius < 0:
            pdb.gimp_selection_shrink(image,-radius)
        else:
            pdb.gimp_selection_grow(image,radius)
			
        if feather_radius !=0:
            pdb.gimp_selection_feather(image,feather_radius)
			
        pdb.gimp_selection_invert(image)	
        pdb.gimp_edit_clear(image.layers[0])
	
        if global_param3!=100 :
            wL = pdb.gimp_drawable_width(pdb.gimp_image_get_layer_by_name(image, "Result"))
            hL = pdb.gimp_drawable_height(pdb.gimp_image_get_layer_by_name(image, "Result"))

            new_w=(wL*global_param3)/100 
            new_h=(hL*global_param3)/100
			
            pdb.gimp_layer_scale(pdb.gimp_image_get_layer_by_name(image, "Result"), new_w, new_h, 1) 			
            pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Result"))
			
        if global_param9 !=0:	
            pdb.gimp_selection_none(image)
 			
            angle = global_param9/180.0 * math.pi
            item = pdb.gimp_item_transform_rotate(pdb.gimp_image_get_layer_by_name(image, "Result"),angle,1,0,0)
            if pdb.gimp_layer_is_floating_sel(item):
                floating=pdb.gimp_floating_sel_anchor(item)

            pdb.gimp_image_select_item(image, 2, pdb.gimp_image_get_layer_by_name(image, "Result"))				
            pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Result"))
            pdb.gimp_selection_invert(image)	
            pdb.gimp_edit_clear(image.layers[0])	
				
				
        if global_param10 !=0 or global_param11 !=0:            
            pdb.gimp_image_select_item(image, 2, pdb.gimp_image_get_layer_by_name(image, "Result"))
            a,b = pdb.gimp_drawable_offsets(pdb.gimp_image_get_layer_by_name(image, "Result"))
            pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Result"))

            pdb.gimp_layer_set_offsets(pdb.gimp_image_get_layer_by_name(image, "Result"), a+global_param10, -(b+global_param11))
            pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Result"))
        if feather_radius !=0:
            pdb.gimp_selection_none(image)		
            pdb.gimp_image_select_item(image, 2, pdb.gimp_image_get_layer_by_name(image, "Result"))
            pdb.gimp_selection_feather(image,feather_radius)
            pdb.gimp_selection_invert(image)	
            pdb.gimp_edit_clear(image.layers[0])		

        if global_param6 !=100:
            pdb.gimp_layer_set_opacity(pdb.gimp_image_get_layer_by_name(image, "Result"), global_param6)
			
        pdb.gimp_selection_none(image)	
        pdb.gimp_item_set_visible(image.layers[0], 1)	
        pdb.gimp_item_set_visible(image.layers[1], 0)	
		
    gimp.displays_flush()
        

def apply_final(layer): #wrapper to apply effect on final and remove preview_layer meant to be called by on_ok_button_clicked
    global preview_layer
    pdb.gimp_image_undo_enable(image) #so that user can undo this next step

      	
    if has_preview:

        pdb.gimp_image_remove_channel(image,selection_channel) #so that we don't leave a saved channel laying around

    pdb.gimp_image_set_active_layer(image,drawable)

    gimp.displays_flush()
   
# Function to update the live preview
def update_live_preview(): #this is called everytime some parameter changes
    global global_param0, global_param1, global_param2, global_param3, global_param4, global_param5,global_param6, global_param7, global_param8, global_param9, global_param10, global_param11
    global image,drawable
    global has_preview,preview_layer #deal with preview layer
    global selection_channel #this will save our current selection

    if not has_preview : #create a preview layer

        preview_layer = pdb.gimp_layer_new_from_drawable(image.layers[0], image)
        pdb.gimp_image_insert_layer(image,preview_layer,None,0) #insert top most so we see it
        preview_layer.name = "Preview"
		
        non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(image)
	
        if non_empty == TRUE:
            pass #there's already a selection
        else:
            pdb.gimp_selection_all(image) #if there's no selection we just select the whole image and work with that   
        selection_channel = pdb.gimp_selection_save(image)
        has_preview = True #now set it true so we can deal with existing layer in later calls
    else: # already have preview layer
        pass
    pdb.gimp_image_remove_layer(image,preview_layer) #remove it to create a new one to work on
	
    preview_layer = pdb.gimp_layer_new_from_drawable(image.layers[0], image)
    pdb.gimp_image_insert_layer(image,preview_layer,None,0) #insert top most so we see it
    preview_layer.name = "Result"

	        
    pdb.gimp_image_set_active_layer(image,preview_layer)
    apply_effect(preview_layer)
   

def dialog(image_, drawable_):
    global image, drawable, save_foreground

        
    if not has_preview:    
        non_empty,x1,y1,x2,y2=pdb.gimp_selection_bounds(image_)    # get limits of selection bounding box
        h_box = x2-x1                                              # horizontal width of bounding box
        v_box = y2-y1                                              # vertical height of bounding box
    
        width = image_.width
        height = image_.height
    

        if h_box == width and v_box == height:                     # this is select all
            h1_slider_lower = min(((h_box - 1)/2),((v_box - 1)/2))
            h1_slider_limit = 0
            h2_slider_lower = 0
            h2_slider_limit = min((height*0.5),(width*0.5))
        else:
            h1_slider_limit = min((height*0.5),(width*0.5))
            h1_slider_lower = min(((h_box - 1)/2),((v_box - 1)/2))
            h2_slider_lower = 0
            h2_slider_limit = min((height*0.5),(width*0.5))
        
        h7_slider_limit = (width - x1) - 1
        h7_slider_lower = (-x2) + 1
    
        h8_slider_limit = (height - y1) - 1
        h8_slider_lower = (-y2) + 1      

        h4_slider_limit = (-width + x1) + 1
        h4_slider_lower = (-x2) + 1
    
        h5_slider_limit = (-height + y1) - 1
        h5_slider_lower = (-y2) + 1  

        h10_slider_limit = width - 1
        h10_slider_lower = - width + 1 

        h11_slider_limit = height - 1
        h11_slider_lower = - height + 1 
		
    #save these for updates
    image = image_
    pdb.gimp_image_undo_disable(image) #for speed and also when user undo it doesn't see our preview creations/deletions
    drawable = drawable_ 

    #-------------------------------------------------------------
    dialog = gtk.Dialog("Apply Selection to Layer with Live Preview.", None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT)
    dialog.set_default_size(425, 400)

    #-------------------------------------------------------------	
    hbox100 = gtk.HBox()
    dialog.vbox.pack_start(hbox100, expand=True, fill=True)
    pattern_label = gtk.Label(" Apply selection and adjustment from top layer to bottom layer. Ver.2.1.\n If there is no selection, the entire image is selected and Move = Crop\n")	
    hbox100.pack_start(pattern_label, expand=True, fill=True, padding=1)
	
    #-------------------------------------------------------------
    #hbox0 = gtk.HBox()
    #dialog.vbox.pack_start(hbox0, expand=True, fill=True)
    #pattern_label = gtk.Label("\nSelection")	
    #hbox0.pack_start(pattern_label, expand=True, fill=True, padding=5)
	
    #-------------------------------------------------------------
    hbox = gtk.HBox()
    dialog.vbox.pack_start(hbox, expand=True, fill=True)
    label1 = gtk.Label("    Border:\n-shrink | +grow")
    hbox.pack_start(label1, expand=False, fill=False, padding=5)
    adjustment1 = gtk.Adjustment(value=-1, lower=-(h1_slider_lower), upper=h1_slider_limit, step_incr=1, page_incr=0) # set slider lower & upper limits
    param1_scale = gtk.HScale(adjustment=adjustment1)
    param1_scale.set_digits(0)  # Display only integers
    hbox.pack_start(param1_scale, expand=True, fill=True, padding=5)
    label1 = gtk.SpinButton(adjustment1,0, 0 )
    hbox.pack_start(label1, expand=False, fill=False, padding=5)
    param1_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######   
    param1_scale.connect("value-changed", on_param1_changed)

    #-------------------------------------------------------------
    hbox7 = gtk.HBox()
    dialog.vbox.pack_start(hbox7, expand=True, fill=True)
    label7 = gtk.Label("\nMove X-LR (px):")
    hbox7.pack_start(label7, expand=False, fill=False, padding=5)
    adjustment7 = gtk.Adjustment(value=0, lower=0, upper=h7_slider_limit, step_incr=1, page_incr=0)
    param7_scale = gtk.HScale(adjustment=adjustment7)
    param7_scale.set_digits(0)  # Display only integers
    hbox7.pack_start(param7_scale, expand=True, fill=True, padding=5)
    label7 = gtk.SpinButton(adjustment7,0, 0 )
    hbox7.pack_start(label7, expand=False, fill=False, padding=5)
    param7_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######	
    param7_scale.connect("value-changed", on_param7_changed)

    #------------------------------------------------------------
    hbox4 = gtk.HBox()
    dialog.vbox.pack_start(hbox4, expand=True, fill=True)
    label4 = gtk.Label("\nMove X-RL (px):")
    hbox4.pack_start(label4, expand=False, fill=False, padding=5)
    adjustment4 = gtk.Adjustment(value=0, lower=h4_slider_lower, upper=0, step_incr=1, page_incr=0)
    param4_scale = gtk.HScale(adjustment=adjustment4)
    param4_scale.set_digits(0)  # Display only integers
    hbox4.pack_start(param4_scale, expand=True, fill=True, padding=5)
    label4 = gtk.SpinButton(adjustment4,0, 0 )
    hbox4.pack_start(label4, expand=False, fill=False, padding=5)
    param4_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######	
    param4_scale.connect("value-changed", on_param4_changed)
	
    #-------------------------------------------------------------
    hbox8 = gtk.HBox()
    dialog.vbox.pack_start(hbox8, expand=True, fill=True)
    label8 = gtk.Label("\nMove Y TB (px):")
    hbox8.pack_start(label8, expand=False, fill=False, padding=5)
    adjustment8 = gtk.Adjustment(value=0, lower=0, upper=h8_slider_limit, step_incr=1, page_incr=0)
    param8_scale = gtk.HScale(adjustment=adjustment8)
    param8_scale.set_digits(0)  # Display only integers
    hbox8.pack_start(param8_scale, expand=True, fill=True, padding=5)
    label8 = gtk.SpinButton(adjustment8,0, 0 )
    hbox8.pack_start(label8, expand=False, fill=False, padding=5)
    param8_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######	
    param8_scale.connect("value-changed", on_param8_changed)
	
    #-------------------------------------------------------------
    hbox5 = gtk.HBox()
    dialog.vbox.pack_start(hbox5, expand=True, fill=True)
    label5 = gtk.Label("\nMove Y BT (px):")
    hbox5.pack_start(label5, expand=False, fill=False, padding=5)
    adjustment5 = gtk.Adjustment(value=0, lower=h5_slider_lower, upper=0, step_incr=1, page_incr=0)
    param5_scale = gtk.HScale(adjustment=adjustment5)
    param5_scale.set_digits(0)  # Display only integers
    hbox5.pack_start(param5_scale, expand=True, fill=True, padding=5)
    label5 = gtk.SpinButton(adjustment5,0, 0 )
    hbox5.pack_start(label5, expand=False, fill=False, padding=5)
    param5_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######	
    param5_scale.connect("value-changed", on_param5_changed)

    #-------------------------------------------------------------	
	
	
    hbox2 = gtk.HBox()
    dialog.vbox.pack_start(hbox2, expand=True, fill=True)
    label2 = gtk.Label("\nFeather Radius:")
    hbox2.pack_start(label2, expand=False, fill=False, padding=5)
    adjustment2 = gtk.Adjustment(value=0, lower=h2_slider_lower, upper=h2_slider_limit, step_incr=1, page_incr=0) # set feather slider upper limit
    param2_scale = gtk.HScale(adjustment=adjustment2)
    param2_scale.set_digits(0)  # Display only integers
    hbox2.pack_start(param2_scale, expand=True, fill=True, padding=5)
    label2 = gtk.SpinButton(adjustment2,0, 0 )
    hbox2.pack_start(label2, expand=False, fill=False, padding=5)
    param2_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######	
    param2_scale.connect("value-changed", on_param2_changed)
	
    #-------------------------------------------------------------
    #hbox0 = gtk.HBox()
    #dialog.vbox.pack_start(hbox0, expand=True, fill=True)
    #pattern_label = gtk.Label("\nLayer")	
    #hbox0.pack_start(pattern_label, expand=True, fill=True, padding=5)
	
    #-------------------------------------------------------------
    hbox3 = gtk.HBox()
    dialog.vbox.pack_start(hbox3, expand=True, fill=True)  
    label3 = gtk.Label("\nScale (%):")
    hbox3.pack_start(label3, expand=False, fill=False, padding=5)
    adjustment3 = gtk.Adjustment(value=100, lower=-1, upper=400, step_incr=1, page_incr=0) # set slider lower & upper limits
    param3_scale = gtk.HScale(adjustment=adjustment3)
    param3_scale.set_digits(0)  # Display only integers
    hbox3.pack_start(param3_scale, expand=True, fill=True, padding=5)
    label3 = gtk.SpinButton(adjustment3,0, 0 )
    hbox3.pack_start(label3, expand=False, fill=False, padding=5)
    param3_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######   
    param3_scale.connect("value-changed", on_param3_changed)

    #-------------------------------------------------------------
    hbox10 = gtk.HBox()
    dialog.vbox.pack_start(hbox10, expand=True, fill=True)
    label10 = gtk.Label("\nOff X (px):")
    hbox10.pack_start(label10, expand=False, fill=False, padding=5)
    adjustment10 = gtk.Adjustment(value=0, lower=h10_slider_lower, upper=h10_slider_limit, step_incr=1, page_incr=0)
    param10_scale = gtk.HScale(adjustment=adjustment10)
    param10_scale.set_digits(0)  # Display only integers
    hbox10.pack_start(param10_scale, expand=True, fill=True, padding=5)
    label10 = gtk.SpinButton(adjustment10,0, 0 )
    hbox10.pack_start(label10, expand=False, fill=False, padding=5)
    param10_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######	
    param10_scale.connect("value-changed", on_param10_changed)
	
    #-------------------------------------------------------------
    hbox11 = gtk.HBox()
    dialog.vbox.pack_start(hbox11, expand=True, fill=True)
    label11 = gtk.Label("\nOff Y (px):")
    hbox11.pack_start(label11, expand=False, fill=False, padding=5)
    adjustment11 = gtk.Adjustment(value=0, lower=h11_slider_lower, upper=h11_slider_limit, step_incr=1, page_incr=0)
    param11_scale = gtk.HScale(adjustment=adjustment11)
    param11_scale.set_digits(0)  # Display only integers
    hbox11.pack_start(param11_scale, expand=True, fill=True, padding=5)
    label11 = gtk.SpinButton(adjustment11,0, 0 )
    hbox11.pack_start(label11, expand=False, fill=False, padding=5)
    param11_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######	
    param11_scale.connect("value-changed", on_param11_changed)

    #-------------------------------------------------------------
    hbox9 = gtk.HBox()
    dialog.vbox.pack_start(hbox9, expand=True, fill=True)
    label9 = gtk.Label("\nRotate:  ")
    hbox9.pack_start(label9, expand=False, fill=False, padding=9)
    adjustment9 = gtk.Adjustment(value=0, lower=-180, upper=180, step_incr=1, page_incr=0)
    param9_scale = gtk.HScale(adjustment=adjustment9)
    param9_scale.set_digits(0)  # Display only integers
    hbox9.pack_start(param9_scale, expand=True, fill=True, padding=5)
    label9 = gtk.SpinButton(adjustment9,0, 0 )
    hbox9.pack_start(label9, expand=False, fill=False, padding=5)
    param9_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######	
    param9_scale.connect("value-changed", on_param9_changed)


    #-------------------------------------------------------------
    hbox6 = gtk.HBox()
    dialog.vbox.pack_start(hbox6, expand=True, fill=True)
    label6 = gtk.Label("\nOpacity:  ")
    hbox6.pack_start(label6, expand=False, fill=False, padding=6)
    adjustment6 = gtk.Adjustment(value=100, lower=-0, upper=100, step_incr=1, page_incr=0)
    param6_scale = gtk.HScale(adjustment=adjustment6)
    param6_scale.set_digits(0)  # Display only integers
    hbox6.pack_start(param6_scale, expand=True, fill=True, padding=5)
    label6 = gtk.SpinButton(adjustment6,0, 0 )
    hbox6.pack_start(label6, expand=False, fill=False, padding=5)
    param6_scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS) ######	
    param6_scale.connect("value-changed", on_param6_changed)
    # -------------------------------------------------------------
    hbox121 = gtk.HBox()
    dialog.vbox.pack_start(hbox121, expand=True, fill=True)
    toggle_button = gtk.ToggleButton()
    dialog.action_area.add(toggle_button)	
    update_toggle_button_label(toggle_button)
    toggle_button.connect("toggled", on_toggle_button_toggled)
    hbox121.pack_start(toggle_button, expand=False, fill=False, padding=5) 
	
    # -------------------------------------------------------------	
    cancel_buton = dialog.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
    cancel_buton.connect("clicked", cancel)
	
    # -------------------------------------------------------------	
	
    # Add an OK button
    ok_button = dialog.add_button(gtk.STOCK_OK, gtk.RESPONSE_OK)
    ok_button.connect("clicked", on_ok_button_clicked)
    # Show the dialog
    dialog.show_all()
    update_live_preview() #call this once so we see effect
    dialog.run()
 	
	#--------------------------------------------------

def on_toggle_button_toggled(button):
    global proceed_with_changes
    proceed_with_changes = not proceed_with_changes
    update_toggle_button_label(button)

def update_toggle_button_label(button):
    label = "Preview = Yes\n*Click to Stop" if proceed_with_changes else "Preview = No \n*Click to Start"
    button.set_label(label)	
    update_live_preview()

    # ------------------------------------------------------------
 
def cancel(cancel_buton, data=None):
    global preview_layer
    pdb.gimp_image_remove_layer(image,preview_layer)
    pdb.gimp_image_select_item(image, 2, selection_channel)	
    pdb.gimp_image_remove_channel(image, selection_channel)	
	
def on_param1_changed(scale):
    global global_param1
    global_param1 = scale.get_value()
    update_live_preview()

def on_param2_changed(scale):
    global global_param2
    global_param2 = scale.get_value()
    update_live_preview()
	
def on_param3_changed(scale):
    global global_param3
    global_param3 = scale.get_value()
    update_live_preview()

def on_param4_changed(scale):
    global global_param4
    global_param4 = scale.get_value()
    update_live_preview()
	
def on_param5_changed(scale):
    global global_param5
    global_param5 = scale.get_value()
    update_live_preview()	

def on_param6_changed(scale):
    global global_param6
    global_param6 = scale.get_value()
    update_live_preview()
	
def on_param7_changed(scale):
    global global_param7
    global_param7 = scale.get_value()
    update_live_preview()

def on_param8_changed(scale):
    global global_param8
    global_param8 = scale.get_value()
    update_live_preview()

def on_param9_changed(scale):
    global global_param9
    global_param9 = scale.get_value()
    update_live_preview()

def on_param10_changed(scale):
    global global_param10
    global_param10 = scale.get_value()
    update_live_preview()
	
def on_param11_changed(scale):
    global global_param11
    global_param11 = scale.get_value()
    update_live_preview()
	
def on_ok_button_clicked(button, data=None):
    global drawable
    apply_final(preview_layer) 
    button.get_toplevel().destroy() 
	
# Register the Python-Fu plugin
register(
    "python_fu_apply_to_layer_live",
    "Apply a selection transformation to a layer using live preview",
    "Transform a selection and/or layer with Live Preview",
    "TT/David/MrQ",
    "GPL",
    "07/02/2024",
    "<Image>/Select/Modify/Apply to Layer LP...",  # Menu location
    "*",  # Image type
    [],
    [],
    dialog
)

main()
